<?php

namespace OtomaticAi\Controllers;

use Exception;
use OtomaticAi\Api\OtomaticAi\Client;
use OtomaticAi\Utils\Cache;

class NewsBannerController extends Controller
{
    private string $cacheKey = "otomatic_ai_news_banners";
    private int $cacheSeconds = 300;

    public function __invoke()
    {
        $this->verifyNonce();

        $cached = Cache::get($this->cacheKey, []);
        if ($cached->isOutdated($this->cacheSeconds)) {
            try {
                $api = new Client;
                $data = $api->newsBanners();

                Cache::store($this->cacheKey, $data);
            } catch (Exception $e) {
            }
        }

        $cached = Cache::get($this->cacheKey, []);

        $this->response($cached->data);
    }
}
