<?php

namespace OtomaticAi\Controllers\Settings;

use Exception;
use OtomaticAi\Api\OpenAi\Client as OpenAiClient;
use OtomaticAi\Api\OpenAi\Exceptions\AuthentificationException as OpenAiAuthentificationException;
use OtomaticAi\Api\MistralAi\Client as MistralAiClient;
use OtomaticAi\Api\Groq\Client as GroqClient;
use OtomaticAi\Api\MistralAi\Exceptions\AuthentificationException as MistralAiAuthentificationException;
use OtomaticAi\Api\Groq\Exceptions\AuthentificationException as GroqAuthentificationException;
use OtomaticAi\Api\StabilityAi\Client as StabilityAiClient;
use OtomaticAi\Api\StabilityAi\Exceptions\AuthentificationException as StabilityAiAuthentificationException;
use OtomaticAi\Api\DeepSeek\Client as DeepSeekClient;
use OtomaticAi\Api\DeepSeek\Exceptions\AuthentificationException as DeepSeekAuthentificationException;
use OtomaticAi\Api\Gemini\Client as GeminiClient;
use OtomaticAi\Api\Gemini\Exceptions\AuthentificationException as GeminiAuthentificationException;
use OtomaticAi\Controllers\Controller;
use OtomaticAi\Utils\Auth;
use OtomaticAi\Utils\Settings;

class GlobalSystemsController extends Controller
{
    /**
     * Get the api settings
     *
     * @return void
     */
    public function index()
    {
        $this->verifyNonce();

        $this->response(Settings::get('global_systems'));
    }

    /**
     * Update the global systems settings.
     * 
     * @return void
     */
    public function update()
    {
        $this->verifyNonce();

        $this->validate([
            "text_instructions" => ["nullable", "string"],
        ]);

        Settings::update($this->request, 'global_systems');
        Settings::save();

        $this->emptyResponse();
    }
}
