<?php

namespace OtomaticAi\Models\Presets;

use OtomaticAi\Api\XAi\Client as XAiClient;
use OtomaticAi\Api\XAi\PoolClient as PoolXAiClient;

class XAIPreset extends Preset
{
    /**
     * Create the xAI API payload
     *
     * @param array $params
     * @return array
     */
    public function payload(array $params = []): array
    {
        $model = $this->model;
        if ($model === "grok-2") {
            $model = "grok-2-latest";
        }

        $payload = [
            "model" => $model,
            "temperature" => $this->temperature ? intval($this->temperature) : 1,
            "top_p" => $this->top_p ? intval($this->top_p) : 1,
            "stream" => false,
            "messages" => $this->replaceMessagesVariables($params),
        ];

        return $payload;
    }

    public function process(array $params = [])
    {
        $api = new XAiClient;
        return $api->chat($this->payload($params));
    }

    public function processPool(array $params = [])
    {
        $api = new PoolXAiClient;
        $params = array_map(function ($p) {
            return $this->payload($p);
        }, $params);
        return $api->chat($params);
    }
}
